Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HiveService.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HiveService.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HiveService.cs	(revision 4598)
@@ -9,6 +9,9 @@
 using System.IO;
 using System.Security.Permissions;
+using System.Data.Linq;
 
 namespace HeuristicLab.Services.Hive {
+
+
   /// <summary>
   /// Implementation of the Hive service (interface <see cref="IHiveService"/>).
@@ -16,103 +19,127 @@
   [ServiceBehavior(IncludeExceptionDetailInFaults = true)]
   public class HiveService : IHiveService {
-    private DataAccess.IContextFactory contextFactory = new DataAccess.ContextFactory();
+    private DataAccess.IHiveDao dao { 
+      get { return ServiceLocator.Instance.HiveDao; } 
+    }
+    private DataAccess.IContextFactory<DataAccess.HiveDataContext> contextFactory { 
+      get { return ServiceLocator.Instance.ContextFactory; } 
+    }
+    private IAuthorizationManager auth {
+      get { return ServiceLocator.Instance.AuthorizationManager; }
+    }
 
     #region Job Methods
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
-    public Guid AddJob(JobData dto) {
-      using (contextFactory.GetContext()) {
-        DataAccess.Job entity = Convert.ToEntity(dto); entity.Id = 0;
-        okb.Platforms.InsertOnSubmit(entity);
-        okb.SubmitChanges();
-        return entity.Id;
-      }
-    }
-
-    public Job AddJobWithGroupStrings(JobData jobObj, IEnumerable<string> groups) {
-      throw new NotImplementedException();
-    }
-
-    public JobData GetLastSerializedResult(Guid jobId) {
-      throw new NotImplementedException();
-    }
-
+    public Guid AddJob(Job jobDto, JobData jobDataDto) {
+      using (contextFactory.GetContext()) {
+        jobDataDto.JobId = dao.AddJob(jobDto);
+        dao.AddJobData(jobDataDto);
+        return jobDataDto.JobId;
+      }
+    }
+
+    public Guid AddChildJob(Guid parentJobId, Job jobDto, JobData jobDataDto) {
+      jobDto.ParentJobId = parentJobId;
+      return AddJob(jobDto, jobDataDto);
+    }
+
+    public Job GetJob(Guid jobId) {
+      using (contextFactory.GetContext()) {
+        return dao.GetJob(jobId);
+      }
+    }
+
+    public IEnumerable<Job> GetJobs() {
+      using (contextFactory.GetContext()) {
+        return dao.GetJobs(x => true);
+      }
+    }
+
+    public IEnumerable<LightweightJob> GetLightweightJobs(IEnumerable<Guid> jobIds) {
+      using (contextFactory.GetContext()) {
+        return dao.GetJobs(x => jobIds.Contains(x.JobId)).Select(x => new LightweightJob(x)).ToArray();
+      }
+    }
+
+    public IEnumerable<LightweightJob> GetLightweightChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
+      using (contextFactory.GetContext()) {
+        return GetChildJobs(parentJobId, recursive, includeParent).Select(x => new LightweightJob(x)).ToArray();
+      }
+    }
+
+    // formerly GetLastSerializedResult
+    public JobData GetJobData(Guid jobId) {
+      using (contextFactory.GetContext()) {
+        return dao.GetJobData(jobId);
+      }
+    }
+
+    public Stream GetJobDataStreamed(Guid jobId) {
+      throw new NotImplementedException();
+    }
+
+    public void UpdateJob(Job jobDto, JobData jobDataDto) {
+      using (contextFactory.GetContext()) {
+        dao.UpdateJob(jobDto);
+        dao.UpdateJobData(jobDataDto);
+      }
+    }
+
+    public void UpdateJobDataStreamed(Stream stream) {
+      throw new NotImplementedException();
+    }
+
+    public void DeleteChildJobs(Guid jobId) {
+      using (contextFactory.GetContext()) {
+        var jobs = GetChildJobs(jobId, true, false);
+        foreach (var job in jobs) {
+          dao.DeleteJob(job.Id);
+          dao.DeleteJobData(job.Id);
+        };
+      }
+    }
+
+    public Job AquireJob(Guid slaveId) {
+      throw new NotImplementedException();
+    }
+    #endregion
+
+
+    #region Job Control Methods
     public void AbortJob(Guid jobId) {
       throw new NotImplementedException();
     }
-
-    public Job GetJobById(Guid jobId) {
-      throw new NotImplementedException();
-    }
-
-    public IEnumerable<LightweightJob> GetJobResults(IEnumerable<Guid> jobIds) {
-      throw new NotImplementedException();
-    }
-
-    public IEnumerable<LightweightJob> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent) {
-      throw new NotImplementedException();
-    }
-
-    public Job AddChildJob(Guid parentJobId, JobData serializedJob) {
-      throw new NotImplementedException();
-    }
-
-    public Job GetAllJobsWithFilter(JobState jobState, int offset, int count) {
-      throw new NotImplementedException();
-    }
-
-    public Job GetAllJobs() {
-      throw new NotImplementedException();
-    }
-
-    public Job GetJobByIdWithDetails(Guid jobId) {
-      throw new NotImplementedException();
-    }
-
-    public Job AddNewJob(JobData job) {
-      throw new NotImplementedException();
-    }
-
     public Job PauseJob(JobData serializedJob) {
       throw new NotImplementedException();
     }
-
-    public void DeleteChildJobs(Guid jobId) {
-      throw new NotImplementedException();
-    }
-
-    public Job GetJob(Guid clientId) {
-      throw new NotImplementedException();
-    }
-
-    public void StoreFinishedJobResult(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
-      throw new NotImplementedException();
-    }
-
-    public void IsJobStillNeeded(Guid jobId) {
-      throw new NotImplementedException();
-    }
-
-    public Stream GetStreamedJob(Guid clientId) {
-      throw new NotImplementedException();
-    }
-
-    public void StoreFinishedJobResultStreamed(Stream stream) {
-      throw new NotImplementedException();
-    }
-
-    #endregion
+    #endregion
+
 
     #region HiveExperiment Methods
     public IEnumerable<HiveExperiment> GetHiveExperiments() {
-      throw new NotImplementedException();
-    }
-
-    public HiveExperiment UpdateHiveExperiment(HiveExperiment hiveExperimentDto) {
-      throw new NotImplementedException();
+      using (contextFactory.GetContext()) {
+        return dao.GetHiveExperiments(x => x.UserId == auth.UserId);
+      }
+    }
+
+    public void UpdateHiveExperiment(HiveExperiment hiveExperimentDto) {
+      using (contextFactory.GetContext()) {
+        dao.UpdateHiveExperiment(hiveExperimentDto);
+      }
     }
 
     public void DeleteHiveExperiment(Guid hiveExperimentId) {
-      throw new NotImplementedException();
+      using (contextFactory.GetContext()) {
+        HiveExperiment he = dao.GetHiveExperiment(hiveExperimentId);
+        if(he.RootJobId.HasValue) {
+          var jobs = GetChildJobs(he.RootJobId.Value, true, true);
+          foreach(var j in jobs) {
+            dao.DeleteJobData(j.Id);
+            dao.DeleteJob(j.Id);
+          }
+        }
+        dao.DeleteHiveExperiment(hiveExperimentId);
+      }
     }
     #endregion
@@ -189,32 +216,60 @@
 
     #region Slave Methods
-    public IEnumerable<Slave> GetAllSlaves() {
-      throw new NotImplementedException();
-    }
-
-    public IEnumerable<SlaveGroup> GetAllSlaveGroups() {
-      throw new NotImplementedException();
-    }
-
-    public IEnumerable<SlaveGroup> GetAllGroupsOfResource(Guid resourceId) {
-      throw new NotImplementedException();
-    }
-
-    public SlaveGroup AddSlaveGroup(SlaveGroup clientGroup) {
-      throw new NotImplementedException();
-    }
-
-    public void DeleteSlaveGroup(Guid clientGroupId) {
-      throw new NotImplementedException();
-    }
-
-    public void AddResourceToGroup(Guid clientGroupId, Resource resource) {
-      throw new NotImplementedException();
-    }
-
-    public void DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
-      throw new NotImplementedException();
-    }
-    #endregion
+    public Guid AddSlaveGroup(SlaveGroup slaveGroup) {
+      using (contextFactory.GetContext()) {
+        return dao.AddSlaveGroup(slaveGroup);
+      }
+    }
+
+    public IEnumerable<Slave> GetSlaves() {
+      using (contextFactory.GetContext()) {
+        return dao.GetSlaves(x => true);
+      }
+    }
+
+    public IEnumerable<SlaveGroup> GetSlaveGroups() {
+      using (contextFactory.GetContext()) {
+        return dao.GetSlaveGroups(x => true);
+      }
+    }
+    
+    public void DeleteSlaveGroup(Guid slaveGroupId) {
+      using (contextFactory.GetContext()) {
+        dao.DeleteSlaveGroup(slaveGroupId);
+      }
+    }
+
+    public void AddResourceToGroup(Guid slaveGroupId, Resource resource) {
+      using (contextFactory.GetContext()) {
+        throw new NotImplementedException();        
+      }
+    }
+
+    public void RemoveResourceFromGroup(Guid clientGroupId, Guid resourceId) {
+      using (contextFactory.GetContext()) {
+        throw new NotImplementedException();
+      }
+    }
+    #endregion
+
+    #region Helper Methods
+    private IEnumerable<Job> GetChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
+      var jobs = new List<Job>(dao.GetJobs(x => parentJobId == null ? !x.ParentJobId.HasValue : x.ParentJobId.Value == parentJobId));
+
+      if (includeParent) {
+        jobs.Add(GetJob(parentJobId.Value));
+      }
+
+      if (recursive) {
+        var childs = new List<Job>();
+        foreach (var job in jobs) {
+          childs.AddRange(GetChildJobs(job.Id, recursive, false));
+        }
+        jobs.AddRange(childs);
+      }
+      return jobs;
+    }
+    #endregion
+
 
   }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/Interfaces/IAuthorizationManager.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/Interfaces/IAuthorizationManager.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/Interfaces/IAuthorizationManager.cs	(revision 4598)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+namespace HeuristicLab.Services.Hive {
+  public interface IAuthorizationManager {
+    /// <summary>
+    /// Returns the UserId of the currently authenticated user
+    /// </summary>
+    Guid UserId { get; }
+
+    /// <summary>
+    /// Checks if the user is allowed to access all the jobs.
+    /// throws an exception if one of those jobs is inaccessible
+    /// </summary>
+    /// <exception cref="SecurityException">thrown when access denied</exception>
+    void AuthorizeJobs(params Guid[] jobId);
+
+    /// <summary>
+    /// Compares the current UserId with the given userId and takes appropriate actions if the mismatch
+    /// </summary>
+    void Authorize(Guid userId);
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/LifecycleManager.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/LifecycleManager.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/LifecycleManager.cs	(revision 4598)
@@ -0,0 +1,97 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using HeuristicLab.Tracing;
+
+namespace HeuristicLab.Services.Hive {
+  class LifecycleManager {
+    private AutoResetEvent waitHandle;
+    private Thread thread;
+    private bool shutdownRequested;
+
+    private TimeSpan interval = new TimeSpan(0, 0, 10);
+    public TimeSpan Interval {
+      get { return interval; }
+      set { interval = value; }
+    }
+
+    private int jobsCurrentlyTransfering = 0;
+    public int JobsCurrentlyTransferring {
+      get { return jobsCurrentlyTransfering; }
+      set {
+        if (jobsCurrentlyTransfering != value) {
+          jobsCurrentlyTransfering = value;
+          Logger.Info("JobsCurrentlyTransfering: " + jobsCurrentlyTransfering);
+        }
+      }
+    }
+
+    public void Start() {
+      Thread thread = new Thread(RunHeartbeatThread);
+      thread.Start();
+      using (ServiceLocator.Instance.ContextFactory.GetContext()) {
+        OnStarted();
+      }
+    }
+
+    private void RunHeartbeatThread() {
+      waitHandle = new AutoResetEvent(false);
+      shutdownRequested = false;
+      while (!shutdownRequested) {
+        using (ServiceLocator.Instance.ContextFactory.GetContext(false)) {
+          OnServerHeartbeat();
+        }
+        waitHandle.WaitOne(this.Interval);
+      }
+      waitHandle.Close();
+      using (ServiceLocator.Instance.ContextFactory.GetContext()) {
+        OnStopped();
+      }
+    }
+
+    public void Stop() {
+      shutdownRequested = true;
+      if (waitHandle != null) waitHandle.Set();
+      if (thread != null) thread.Join();
+      thread = null;
+    }
+
+    public event EventHandler ServerHeartbeat;
+    private void OnServerHeartbeat() {
+      var handler = ServerHeartbeat;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler Started;
+    private void OnStarted() {
+      var handler = Started;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler Stopped;
+    private void OnStopped() {
+      var handler = Stopped;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/ServiceLocator.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/ServiceLocator.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/ServiceLocator.cs	(revision 4598)
@@ -0,0 +1,44 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Services.Hive.DataAccess;
+
+namespace HeuristicLab.Services.Hive {
+
+  public class ServiceLocator {
+    private static CreateDataContext<HiveDataContext> contextCreator = new CreateDataContext<HiveDataContext>(ContextFactory<HiveDataContext>.CreateHiveContext);
+
+    private static ServiceLocator instance;
+    public static ServiceLocator Instance {
+      get {
+        if (instance == null) instance = new ServiceLocator();
+        return instance;
+      }
+    }
+
+    private IHiveDao hiveDao;
+    public IHiveDao HiveDao {
+      get {
+        if (hiveDao == null) hiveDao = new HiveDao(ContextFactory);
+        return hiveDao;
+      }
+    }
+
+    private IContextFactory<HiveDataContext> contextFactory;
+    public IContextFactory<HiveDataContext> ContextFactory {
+      get {
+        if(contextFactory == null) contextFactory = new ContextFactory<HiveDataContext>(contextCreator);
+        return contextFactory;
+      }
+    }
+
+    private IAuthorizationManager authorizationManager;
+    public IAuthorizationManager AuthorizationManager {
+      get {
+        if (authorizationManager == null) authorizationManager = new AuthorizationManager();
+        return authorizationManager;
+      }
+    }
+  }
+}
